// awana_grandprix_scoringDlg.cpp : implementation file
//

#include "stdafx.h"
#include "awana_grandprix_scoring.h"
#include "awana_grandprix_scoringDlg.h"

#include "State.h"

#include <string>

#include "DialogEliminate.h"
#include "DialogEditPool.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog {
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD) {
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAwana_grandprix_scoringDlg dialog

#define kInvalidateScoresButtons 0
#define kPoolNumLines 3
#define kPoolButtonsPerLine 10

#define kScoreNumLines 13

CAwana_grandprix_scoringDlg::CAwana_grandprix_scoringDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAwana_grandprix_scoringDlg::IDD, pParent) {
	//{{AFX_DATA_INIT(CAwana_grandprix_scoringDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

  initPoolButtonPointers();

  mOkToInvalidateScoresButtons = false;
  mPoolFirstLineToDisplay = 0;
  mScoreFirstLineToDisplay = 0;
}

void CAwana_grandprix_scoringDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAwana_grandprix_scoringDlg)
	DDX_Control(pDX, IDC_BUTTON_POOL_NULLVALUE, m_button_pool_nullvalue);
	DDX_Control(pDX, IDC_BUTTON_POOL_9_2, m_button_pool_9_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_9_1, m_button_pool_9_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_9_0, m_button_pool_9_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_8_2, m_button_pool_8_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_8_1, m_button_pool_8_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_8_0, m_button_pool_8_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_7_2, m_button_pool_7_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_7_1, m_button_pool_7_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_7_0, m_button_pool_7_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_6_2, m_button_pool_6_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_6_1, m_button_pool_6_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_6_0, m_button_pool_6_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_5_2, m_button_pool_5_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_5_1, m_button_pool_5_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_5_0, m_button_pool_5_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_4_2, m_button_pool_4_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_4_1, m_button_pool_4_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_4_0, m_button_pool_4_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_3_2, m_button_pool_3_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_3_1, m_button_pool_3_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_3_0, m_button_pool_3_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_2_2, m_button_pool_2_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_2_1, m_button_pool_2_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_2_0, m_button_pool_2_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_1_2, m_button_pool_1_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_1_1, m_button_pool_1_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_1_0, m_button_pool_1_0);
	DDX_Control(pDX, IDC_BUTTON_POOL_0_2, m_button_pool_0_2);
	DDX_Control(pDX, IDC_BUTTON_POOL_0_1, m_button_pool_0_1);
	DDX_Control(pDX, IDC_BUTTON_POOL_0_0, m_button_pool_0_0);
	DDX_Control(pDX, IDC_BUTTON_EDIT_SCROLLDOWN, m_button_edit_scrolldown);
	DDX_Control(pDX, IDC_BUTTON_EDIT_SCROLLUP, m_button_edit_scrollup);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_button_edit);
	DDX_Control(pDX, IDC_BUTTON_REDO, m_button_redo);
	DDX_Control(pDX, IDC_BUTTON_UNDO, m_button_undo);
	DDX_Control(pDX, IDC_BUTTON_ELIMINATE, m_button_eliminate);
	DDX_Control(pDX, IDC_BUTTON_NEWROUND, m_button_newround);
	DDX_Control(pDX, IDC_EDIT_SCORES, m_edit_scores);
	DDX_Control(pDX, IDC_BUTTON_SCORES_SCROLLDOWN, m_button_scores_scrolldown);
	DDX_Control(pDX, IDC_BUTTON_SCORES_SCROLLUP, m_button_scores_scrollup);
	DDX_Control(pDX, IDC_CHECK_SCORES_AUTOSCROLL, m_check_scores_autoscroll);
	DDX_Control(pDX, IDC_BUTTON_R2_RECORD, m_button_r2_record);
	DDX_Control(pDX, IDC_BUTTON_R2_P3, m_button_r2_p3);
	DDX_Control(pDX, IDC_BUTTON_R2_P2, m_button_r2_p2);
	DDX_Control(pDX, IDC_BUTTON_R2_P1, m_button_r2_p1);
	DDX_Control(pDX, IDC_BUTTON_R2_P0, m_button_r2_p0);
	DDX_Control(pDX, IDC_CHECK_R2_N3, m_check_r2_n3);
	DDX_Control(pDX, IDC_CHECK_R2_N2, m_check_r2_n2);
	DDX_Control(pDX, IDC_CHECK_R2_N1, m_check_r2_n1);
	DDX_Control(pDX, IDC_CHECK_R2_N0, m_check_r2_n0);
	DDX_Control(pDX, IDC_BUTTON_T2_RACE, m_button_t2_race);
	DDX_Control(pDX, IDC_CHECK_T2_L3, m_check_t2_l3);
	DDX_Control(pDX, IDC_CHECK_T2_L2, m_check_t2_l2);
	DDX_Control(pDX, IDC_CHECK_T2_L1, m_check_t2_l1);
	DDX_Control(pDX, IDC_CHECK_T2_L0, m_check_t2_l0);
	DDX_Control(pDX, IDC_CHECK_T2_N3, m_check_t2_n3);
	DDX_Control(pDX, IDC_CHECK_T2_N2, m_check_t2_n2);
	DDX_Control(pDX, IDC_CHECK_T2_N1, m_check_t2_n1);
	DDX_Control(pDX, IDC_CHECK_T2_N0, m_check_t2_n0);
	DDX_Control(pDX, IDC_BUTTON_T2_RESELECT, m_button_t2_reselect);
	DDX_Control(pDX, IDC_BUTTON_R1_RECORD, m_button_r1_record);
	DDX_Control(pDX, IDC_BUTTON_R1_P3, m_button_r1_p3);
	DDX_Control(pDX, IDC_BUTTON_R1_P2, m_button_r1_p2);
	DDX_Control(pDX, IDC_BUTTON_R1_P1, m_button_r1_p1);
	DDX_Control(pDX, IDC_BUTTON_R1_P0, m_button_r1_p0);
	DDX_Control(pDX, IDC_CHECK_R1_N3, m_check_r1_n3);
	DDX_Control(pDX, IDC_CHECK_R1_N2, m_check_r1_n2);
	DDX_Control(pDX, IDC_CHECK_R1_N1, m_check_r1_n1);
	DDX_Control(pDX, IDC_CHECK_R1_N0, m_check_r1_n0);
	DDX_Control(pDX, IDC_BUTTON_T1_RACE, m_button_t1_race);
	DDX_Control(pDX, IDC_CHECK_T1_L3, m_check_t1_l3);
	DDX_Control(pDX, IDC_CHECK_T1_L2, m_check_t1_l2);
	DDX_Control(pDX, IDC_CHECK_T1_L1, m_check_t1_l1);
	DDX_Control(pDX, IDC_CHECK_T1_L0, m_check_t1_l0);
	DDX_Control(pDX, IDC_CHECK_T1_N3, m_check_t1_n3);
	DDX_Control(pDX, IDC_CHECK_T1_N2, m_check_t1_n2);
	DDX_Control(pDX, IDC_CHECK_T1_N1, m_check_t1_n1);
	DDX_Control(pDX, IDC_CHECK_T1_N0, m_check_t1_n0);
	DDX_Control(pDX, IDC_BUTTON_T1_RESELECT, m_button_t1_reselect);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAwana_grandprix_scoringDlg, CDialog)
	//{{AFX_MSG_MAP(CAwana_grandprix_scoringDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MOVE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_EDIT_SCROLLUP, OnButtonEditScrollup)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_SCROLLDOWN, OnButtonEditScrolldown)
	ON_BN_CLICKED(IDC_CHECK_SCORES_AUTOSCROLL, OnCheckScoresAutoscroll)
	ON_BN_CLICKED(IDC_BUTTON_SCORES_SCROLLUP, OnButtonScoresScrollup)
	ON_BN_CLICKED(IDC_BUTTON_SCORES_SCROLLDOWN, OnButtonScoresScrolldown)
	ON_BN_CLICKED(IDC_BUTTON_T1_RESELECT, OnButtonT1Reselect)
	ON_BN_CLICKED(IDC_BUTTON_T2_RESELECT, OnButtonT2Reselect)
	ON_BN_CLICKED(IDC_BUTTON_T1_RACE, OnButtonT1Race)
	ON_BN_CLICKED(IDC_BUTTON_T2_RACE, OnButtonT2Race)
	ON_BN_CLICKED(IDC_BUTTON_R1_RECORD, OnButtonR1Record)
	ON_BN_CLICKED(IDC_BUTTON_R2_RECORD, OnButtonR2Record)
	ON_BN_CLICKED(IDC_BUTTON_R1_P0, OnButtonR1P0)
	ON_BN_CLICKED(IDC_BUTTON_R1_P1, OnButtonR1P1)
	ON_BN_CLICKED(IDC_BUTTON_R1_P2, OnButtonR1P2)
	ON_BN_CLICKED(IDC_BUTTON_R1_P3, OnButtonR1P3)
	ON_BN_CLICKED(IDC_BUTTON_R2_P0, OnButtonR2P0)
	ON_BN_CLICKED(IDC_BUTTON_R2_P1, OnButtonR2P1)
	ON_BN_CLICKED(IDC_BUTTON_R2_P2, OnButtonR2P2)
	ON_BN_CLICKED(IDC_BUTTON_R2_P3, OnButtonR2P3)
	ON_BN_CLICKED(IDC_BUTTON_UNDO, OnButtonUndo)
	ON_BN_CLICKED(IDC_BUTTON_REDO, OnButtonRedo)
	ON_BN_CLICKED(IDC_CHECK_T1_N0, OnCheckT1N0)
	ON_BN_CLICKED(IDC_CHECK_T1_N1, OnCheckT1N1)
	ON_BN_CLICKED(IDC_CHECK_T1_N2, OnCheckT1N2)
	ON_BN_CLICKED(IDC_CHECK_T1_N3, OnCheckT1N3)
	ON_BN_CLICKED(IDC_CHECK_T2_N0, OnCheckT2N0)
	ON_BN_CLICKED(IDC_CHECK_T2_N1, OnCheckT2N1)
	ON_BN_CLICKED(IDC_CHECK_T2_N2, OnCheckT2N2)
	ON_BN_CLICKED(IDC_CHECK_T2_N3, OnCheckT2N3)
	ON_BN_CLICKED(IDC_CHECK_R1_N0, OnCheckR1N0)
	ON_BN_CLICKED(IDC_CHECK_R1_N1, OnCheckR1N1)
	ON_BN_CLICKED(IDC_CHECK_R1_N2, OnCheckR1N2)
	ON_BN_CLICKED(IDC_CHECK_R1_N3, OnCheckR1N3)
	ON_BN_CLICKED(IDC_CHECK_R2_N0, OnCheckR2N0)
	ON_BN_CLICKED(IDC_CHECK_R2_N1, OnCheckR2N1)
	ON_BN_CLICKED(IDC_CHECK_R2_N2, OnCheckR2N2)
	ON_BN_CLICKED(IDC_CHECK_R2_N3, OnCheckR2N3)
	ON_BN_CLICKED(IDC_BUTTON_POOL_0_0, OnButtonPool00)
	ON_BN_CLICKED(IDC_BUTTON_POOL_1_0, OnButtonPool10)
	ON_BN_CLICKED(IDC_BUTTON_POOL_2_0, OnButtonPool20)
	ON_BN_CLICKED(IDC_BUTTON_POOL_3_0, OnButtonPool30)
	ON_BN_CLICKED(IDC_BUTTON_POOL_4_0, OnButtonPool40)
	ON_BN_CLICKED(IDC_BUTTON_POOL_5_0, OnButtonPool50)
	ON_BN_CLICKED(IDC_BUTTON_POOL_6_0, OnButtonPool60)
	ON_BN_CLICKED(IDC_BUTTON_POOL_7_0, OnButtonPool70)
	ON_BN_CLICKED(IDC_BUTTON_POOL_8_0, OnButtonPool80)
	ON_BN_CLICKED(IDC_BUTTON_POOL_9_0, OnButtonPool90)
	ON_BN_CLICKED(IDC_BUTTON_POOL_0_1, OnButtonPool01)
	ON_BN_CLICKED(IDC_BUTTON_POOL_1_1, OnButtonPool11)
	ON_BN_CLICKED(IDC_BUTTON_POOL_2_1, OnButtonPool21)
	ON_BN_CLICKED(IDC_BUTTON_POOL_3_1, OnButtonPool31)
	ON_BN_CLICKED(IDC_BUTTON_POOL_4_1, OnButtonPool41)
	ON_BN_CLICKED(IDC_BUTTON_POOL_5_1, OnButtonPool51)
	ON_BN_CLICKED(IDC_BUTTON_POOL_6_1, OnButtonPool61)
	ON_BN_CLICKED(IDC_BUTTON_POOL_7_1, OnButtonPool71)
	ON_BN_CLICKED(IDC_BUTTON_POOL_8_1, OnButtonPool81)
	ON_BN_CLICKED(IDC_BUTTON_POOL_9_1, OnButtonPool91)
	ON_BN_CLICKED(IDC_BUTTON_POOL_0_2, OnButtonPool02)
	ON_BN_CLICKED(IDC_BUTTON_POOL_1_2, OnButtonPool12)
	ON_BN_CLICKED(IDC_BUTTON_POOL_2_2, OnButtonPool22)
	ON_BN_CLICKED(IDC_BUTTON_POOL_3_2, OnButtonPool32)
	ON_BN_CLICKED(IDC_BUTTON_POOL_4_2, OnButtonPool42)
	ON_BN_CLICKED(IDC_BUTTON_POOL_5_2, OnButtonPool52)
	ON_BN_CLICKED(IDC_BUTTON_POOL_6_2, OnButtonPool62)
	ON_BN_CLICKED(IDC_BUTTON_POOL_7_2, OnButtonPool72)
	ON_BN_CLICKED(IDC_BUTTON_POOL_8_2, OnButtonPool82)
	ON_BN_CLICKED(IDC_BUTTON_POOL_9_2, OnButtonPool92)
	ON_BN_CLICKED(IDC_BUTTON_POOL_NULLVALUE, OnButtonPoolNullvalue)
	ON_BN_CLICKED(IDC_BUTTON_NEWROUND, OnButtonNewround)
	ON_BN_CLICKED(IDC_BUTTON_ELIMINATE, OnButtonEliminate)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnButtonEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAwana_grandprix_scoringDlg message handlers

BOOL CAwana_grandprix_scoringDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  ::SetWindowPos(m_hWnd, HWND_TOP, 0, 0, 1024, 768, SWP_SHOWWINDOW);

  // set timer for final init
  SetTimer(kInvalidateScoresButtons, 100, 0);

  mModel.initWithTestData();

  // refresh button text from model
  refreshFromModel();

  // randomize
  srand(time(0));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAwana_grandprix_scoringDlg::OnSysCommand(UINT nID, LPARAM lParam) {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAwana_grandprix_scoringDlg::OnPaint() {
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
  }
	else
	{
		CDialog::OnPaint();
	}

  SetTimer(kInvalidateScoresButtons, 100, 0);
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAwana_grandprix_scoringDlg::OnQueryDragIcon() {
	return (HCURSOR) m_hIcon;
}

void CAwana_grandprix_scoringDlg::OnMove(int x, int y) {
	CDialog::OnMove(x, y);	

  // don't move
  ::SetWindowPos(m_hWnd, HWND_TOP, 0, 0, 1024, 768, SWP_SHOWWINDOW);

  SetTimer(kInvalidateScoresButtons, 100, 0);
}

void CAwana_grandprix_scoringDlg::invalidateScoresButtons() {
  if (mOkToInvalidateScoresButtons == false) {
    return;
  }

  // these buttons need to be invalidated because they don't get redrawn properly
  m_check_scores_autoscroll.Invalidate();
  m_button_scores_scrollup.Invalidate();
  m_button_scores_scrolldown.Invalidate();
  m_button_edit.Invalidate();
}

void CAwana_grandprix_scoringDlg::OnTimer(UINT nIDEvent) {
	CDialog::OnTimer(nIDEvent);

  switch (nIDEvent) {
    case kInvalidateScoresButtons :
      {
        mOkToInvalidateScoresButtons = true;
        invalidateScoresButtons();
        KillTimer(nIDEvent);
      }; break;
  }

}

void CAwana_grandprix_scoringDlg::initPoolButtonPointers() {
  // init pool button variables
  mPoolButtons[0][0] = &m_button_pool_0_0;
  mPoolButtons[1][0] = &m_button_pool_1_0;
  mPoolButtons[2][0] = &m_button_pool_2_0;
  mPoolButtons[3][0] = &m_button_pool_3_0;
  mPoolButtons[4][0] = &m_button_pool_4_0;
  mPoolButtons[5][0] = &m_button_pool_5_0;
  mPoolButtons[6][0] = &m_button_pool_6_0;
  mPoolButtons[7][0] = &m_button_pool_7_0;
  mPoolButtons[8][0] = &m_button_pool_8_0;
  mPoolButtons[9][0] = &m_button_pool_9_0;

  mPoolButtons[0][1] = &m_button_pool_0_1;
  mPoolButtons[1][1] = &m_button_pool_1_1;
  mPoolButtons[2][1] = &m_button_pool_2_1;
  mPoolButtons[3][1] = &m_button_pool_3_1;
  mPoolButtons[4][1] = &m_button_pool_4_1;
  mPoolButtons[5][1] = &m_button_pool_5_1;
  mPoolButtons[6][1] = &m_button_pool_6_1;
  mPoolButtons[7][1] = &m_button_pool_7_1;
  mPoolButtons[8][1] = &m_button_pool_8_1;
  mPoolButtons[9][1] = &m_button_pool_9_1;

  mPoolButtons[0][2] = &m_button_pool_0_2;
  mPoolButtons[1][2] = &m_button_pool_1_2;
  mPoolButtons[2][2] = &m_button_pool_2_2;
  mPoolButtons[3][2] = &m_button_pool_3_2;
  mPoolButtons[4][2] = &m_button_pool_4_2;
  mPoolButtons[5][2] = &m_button_pool_5_2;
  mPoolButtons[6][2] = &m_button_pool_6_2;
  mPoolButtons[7][2] = &m_button_pool_7_2;
  mPoolButtons[8][2] = &m_button_pool_8_2;
  mPoolButtons[9][2] = &m_button_pool_9_2;
}

void CAwana_grandprix_scoringDlg::refreshPoolFromModel() {
  // - populate temporary pool structure
  tIntLIST theList;
  tIntLIST::const_iterator theListIter;

  const CState* theState = mModel.getCurrentState();
  for (CState::tIntIntMAP::const_iterator theIter = theState->mPool.begin(); theIter != theState->mPool.end(); theIter++) {
    int theCarID = theIter->first;

    if (mModel.isIDRaceable(theCarID)) {
      theList.push_back(theCarID);
    }
  }

  int theNumItems = theList.size();
  int theNumItemLines = ((theNumItems + kPoolButtonsPerLine) / kPoolButtonsPerLine);
  { // - advance pool display by appropriate amount
    if ((mPoolFirstLineToDisplay + kPoolNumLines) > theNumItemLines) {
      mPoolFirstLineToDisplay = theNumItemLines - kPoolNumLines;
      if (mPoolFirstLineToDisplay < 0) {
        mPoolFirstLineToDisplay = 0;
      }
    }
    
    theListIter = theList.begin();
    for (int i = 0; i < (mPoolFirstLineToDisplay * kPoolButtonsPerLine); i++) {
      theListIter++;
    }
  }

  { // - display
    for (int i = 0; i < kPoolNumLines; i++) {
      for (int j = 0; j < kPoolButtonsPerLine; j++) {
        if (theListIter != theList.end()) {
          char theBuf[1024];
          sprintf(theBuf, "%02d", *theListIter);

          mPoolButtons[j][i]->SetWindowText(theBuf);
          mPoolButtons[j][i]->EnableWindow(true);
          mPoolButtons[j][i]->ShowWindow(SW_SHOW);

          *theListIter++;
        } else {
          mPoolButtons[j][i]->SetWindowText("");
          mPoolButtons[j][i]->EnableWindow(false);
          mPoolButtons[j][i]->ShowWindow(SW_HIDE);
        }
      }
    }
  }

  // - buttons
  m_button_edit_scrollup.EnableWindow(mPoolFirstLineToDisplay > 0);
  m_button_edit_scrolldown.EnableWindow((mPoolFirstLineToDisplay + kPoolNumLines) < theNumItemLines);
}

void CAwana_grandprix_scoringDlg::refreshScoresFromModel() {
  // - text area
  char theBuffer[1024];
  string theStr;

  // get data
  CModel::tIntLIST theRawList = mModel.getIDsWithScores();

  // the list that gets rendered
  CModel::tIntLIST theList;

  { // scroll the list
    if (mScoreFirstLineToDisplay > 0) {
      mScoreFirstLineToDisplay %= theRawList.size();
    } else {
      mScoreFirstLineToDisplay = 0;
    }

    CModel::tIntLIST::const_iterator theRawListIter = theRawList.begin();

    { // offset
      for (int i = 0; i < mScoreFirstLineToDisplay; i++) {
        theRawListIter++;
      }
    }

    { // populate list
      for (int i = 0; i < theRawList.size(); i++) {
        if (theRawListIter == theRawList.end()) {
          theRawListIter = theRawList.begin();
        }

        theList.push_back(*theRawListIter);
        theRawListIter++;
      }
    }
  }

  // render in text area
  for (CModel::tIntLIST::const_iterator theIter = theList.begin(); theIter != theList.end(); theIter++) {
    int theID = *theIter;
    if (theID < 0) {
      continue;
    }
    
    sprintf(theBuffer, "%02d\t:", theID);
    theStr.append(theBuffer);

    CModel::tIntLIST theScores = mModel.getScoresForID(theID);
    for (CModel::tIntLIST::reverse_iterator theIter = theScores.rbegin(); theIter != theScores.rend(); theIter++) {
      int theScore = *theIter;
      
      if (theScore > 0) {
        sprintf(theBuffer, "\t%d", theScore);
      } else {
        strcpy(theBuffer, "\t-");
      }

      theStr.append(theBuffer);
    }

    theStr.append("\r\n");
  }

  int theTabs[16];
  theTabs[0] = 12;
  theTabs[1] = theTabs[0] + 6;
  for (int i = 2; i < 16; i++) {
    theTabs[i] = theTabs[i-1] + 8;
  }

  m_edit_scores.SetTabStops(16, theTabs);
  m_edit_scores.SetWindowText(theStr.c_str());

  // - buttons
  m_button_scores_scrollup.EnableWindow(m_check_scores_autoscroll.GetCheck() == 0);
  m_button_scores_scrolldown.EnableWindow(m_check_scores_autoscroll.GetCheck() == 0);
}

void CAwana_grandprix_scoringDlg::refreshFromModel() {
  // refresh display from data in model
  if (mModel.getRaceableInPool() == 0) {
    m_button_t1_reselect.EnableWindow(false);
    m_button_t2_reselect.EnableWindow(false);
  } else {
    m_button_t1_reselect.EnableWindow(true);
    m_button_t2_reselect.EnableWindow(true);
  }

  // track 1
  m_check_t1_n0.SetWindowText(mModel.trackGetSelectedStr(0, 0));
  m_check_t1_n1.SetWindowText(mModel.trackGetSelectedStr(0, 1));
  m_check_t1_n2.SetWindowText(mModel.trackGetSelectedStr(0, 2));
  m_check_t1_n3.SetWindowText(mModel.trackGetSelectedStr(0, 3));

  m_check_t1_l0.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(0, 0)));
  m_check_t1_l1.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(0, 1)));
  m_check_t1_l2.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(0, 2)));
  m_check_t1_l3.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(0, 3)));

  m_button_t1_race.EnableWindow(mModel.trackGetNumSelected(0) > 0);

  m_check_r1_n0.SetWindowText(mModel.raceGetNumberStr(0, 0));
  m_check_r1_n1.SetWindowText(mModel.raceGetNumberStr(0, 1));
  m_check_r1_n2.SetWindowText(mModel.raceGetNumberStr(0, 2));
  m_check_r1_n3.SetWindowText(mModel.raceGetNumberStr(0, 3));

  m_button_r1_p0.SetWindowText(mModel.raceGetResultStr(0, 0));
  m_button_r1_p1.SetWindowText(mModel.raceGetResultStr(0, 1));
  m_button_r1_p2.SetWindowText(mModel.raceGetResultStr(0, 2));
  m_button_r1_p3.SetWindowText(mModel.raceGetResultStr(0, 3));

  m_button_r1_p0.EnableWindow(mModel.raceGetNumber(0, 0) > -1);
  m_button_r1_p1.EnableWindow(mModel.raceGetNumber(0, 1) > -1);
  m_button_r1_p2.EnableWindow(mModel.raceGetNumber(0, 2) > -1);
  m_button_r1_p3.EnableWindow(mModel.raceGetNumber(0, 3) > -1);

  m_button_r1_record.EnableWindow(mModel.raceGetNumSelected(0) > 0);

  // track 2
  m_check_t2_n0.SetWindowText(mModel.trackGetSelectedStr(1, 0));
  m_check_t2_n1.SetWindowText(mModel.trackGetSelectedStr(1, 1));
  m_check_t2_n2.SetWindowText(mModel.trackGetSelectedStr(1, 2));
  m_check_t2_n3.SetWindowText(mModel.trackGetSelectedStr(1, 3));

  m_check_t2_l0.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(1, 0)));
  m_check_t2_l1.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(1, 1)));
  m_check_t2_l2.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(1, 2)));
  m_check_t2_l3.SetWindowText(mModel.getNameForID(mModel.trackGetSelected(1, 3)));

  m_button_t2_race.EnableWindow(mModel.trackGetNumSelected(1) > 0);

  m_check_r2_n0.SetWindowText(mModel.raceGetNumberStr(1, 0));
  m_check_r2_n1.SetWindowText(mModel.raceGetNumberStr(1, 1));
  m_check_r2_n2.SetWindowText(mModel.raceGetNumberStr(1, 2));
  m_check_r2_n3.SetWindowText(mModel.raceGetNumberStr(1, 3));

  m_button_r2_p0.SetWindowText(mModel.raceGetResultStr(1, 0));
  m_button_r2_p1.SetWindowText(mModel.raceGetResultStr(1, 1));
  m_button_r2_p2.SetWindowText(mModel.raceGetResultStr(1, 2));
  m_button_r2_p3.SetWindowText(mModel.raceGetResultStr(1, 3));

  m_button_r2_p0.EnableWindow(mModel.raceGetNumber(1, 0) > -1);
  m_button_r2_p1.EnableWindow(mModel.raceGetNumber(1, 1) > -1);
  m_button_r2_p2.EnableWindow(mModel.raceGetNumber(1, 2) > -1);
  m_button_r2_p3.EnableWindow(mModel.raceGetNumber(1, 3) > -1);

  m_button_r2_record.EnableWindow(mModel.raceGetNumSelected(1) > 0);

  // pool
  refreshPoolFromModel();

  // scores
  refreshScoresFromModel();

  // undo/redo
  m_button_undo.EnableWindow(mModel.canUndo());
  m_button_redo.EnableWindow(mModel.canRedo());

  // clear all check buttons
  clearAllCheckButtons();
}

void CAwana_grandprix_scoringDlg::OnButtonEditScrollup() {
  if (mPoolFirstLineToDisplay > 0) {
    mPoolFirstLineToDisplay--;
    refreshPoolFromModel();
  }
}

void CAwana_grandprix_scoringDlg::OnButtonEditScrolldown() {
  int theNumItems = mModel.getRaceableInPool();
  int theNumItemLines = ((theNumItems + kPoolButtonsPerLine) / kPoolButtonsPerLine);
  
  if ((mPoolFirstLineToDisplay + kPoolNumLines) < theNumItemLines) {
    mPoolFirstLineToDisplay++;
    refreshPoolFromModel();
  }
}

void CAwana_grandprix_scoringDlg::OnCheckScoresAutoscroll() {
  refreshScoresFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonScoresScrollup() {
  if (mScoreFirstLineToDisplay <= 0) {
    mScoreFirstLineToDisplay = mModel.getIDsWithScores().size();
  }

  mScoreFirstLineToDisplay--;

  refreshScoresFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonScoresScrolldown() {
  mScoreFirstLineToDisplay++;
  mScoreFirstLineToDisplay %= mModel.getIDsWithScores().size();

  refreshScoresFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonT1Reselect() {
  mModel.trackRandomSelect(0, m_check_t1_l0.GetCheck(), m_check_t1_l1.GetCheck(), m_check_t1_l2.GetCheck(), m_check_t1_l3.GetCheck());
  refreshFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonT2Reselect() {
  mModel.trackRandomSelect(1, m_check_t2_l0.GetCheck(), m_check_t2_l1.GetCheck(), m_check_t2_l2.GetCheck(), m_check_t2_l3.GetCheck());
  refreshFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonT1Race() {
  mModel.transferSelectionToRace(0);
  OnButtonT1Reselect();
}

void CAwana_grandprix_scoringDlg::OnButtonT2Race() {
  mModel.transferSelectionToRace(1);
  OnButtonT2Reselect();
}

void CAwana_grandprix_scoringDlg::OnButtonR1Record() {
  mScoreFirstLineToDisplay = 0;
  
  mModel.commitResults(0);
  OnButtonT1Race();
}

void CAwana_grandprix_scoringDlg::OnButtonR2Record() {
  mScoreFirstLineToDisplay = 0;

  mModel.commitResults(1);
  OnButtonT2Race();
}

void CAwana_grandprix_scoringDlg::OnButtonR1P0() {
  mModel.raceSetResult(0, 0);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR1P1() {
  mModel.raceSetResult(0, 1);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR1P2() {
  mModel.raceSetResult(0, 2);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR1P3() {
  mModel.raceSetResult(0, 3);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR2P0() {
  mModel.raceSetResult(1, 0);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR2P1() {
  mModel.raceSetResult(1, 1);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR2P2() {
  mModel.raceSetResult(1, 2);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonR2P3() {
  mModel.raceSetResult(1, 3);
  refreshFromModel(); 
}

void CAwana_grandprix_scoringDlg::OnButtonUndo() {
  mModel.undo();
  refreshFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonRedo() {
  mModel.redo();
  refreshFromModel();
}

void CAwana_grandprix_scoringDlg::clearAllCheckButtons() {
  // clear all checks
  m_check_t1_n0.SetCheck(0);
  m_check_t1_n1.SetCheck(0);
  m_check_t1_n2.SetCheck(0);
  m_check_t1_n3.SetCheck(0);

  m_check_t2_n0.SetCheck(0);
  m_check_t2_n1.SetCheck(0);
  m_check_t2_n2.SetCheck(0);
  m_check_t2_n3.SetCheck(0);

  m_check_r1_n0.SetCheck(0);
  m_check_r1_n1.SetCheck(0);
  m_check_r1_n2.SetCheck(0);
  m_check_r1_n3.SetCheck(0);

  m_check_r2_n0.SetCheck(0);
  m_check_r2_n1.SetCheck(0);
  m_check_r2_n2.SetCheck(0);
  m_check_r2_n3.SetCheck(0);
}

void CAwana_grandprix_scoringDlg::radioCheckButtons(CButton &pExceptButton) {
  // get state for pExceptButton
  int theSavedState;
  theSavedState = pExceptButton.GetCheck();

  // clear all checks
  clearAllCheckButtons();

  // restore state for pExceptButton
  // - also store pExceptButton for future processing by setExceptButton
  if (theSavedState == 1) {
    pExceptButton.SetCheck(theSavedState);
    mExceptButton = &pExceptButton;
  } else {
    mExceptButton = 0;
  }
}

void CAwana_grandprix_scoringDlg::OnCheckT1N0() {
	radioCheckButtons(m_check_t1_n0);
}

void CAwana_grandprix_scoringDlg::OnCheckT1N1() {
	radioCheckButtons(m_check_t1_n1);
}

void CAwana_grandprix_scoringDlg::OnCheckT1N2() {
	radioCheckButtons(m_check_t1_n2);
}

void CAwana_grandprix_scoringDlg::OnCheckT1N3() {
	radioCheckButtons(m_check_t1_n3);
}

void CAwana_grandprix_scoringDlg::OnCheckT2N0() {
	radioCheckButtons(m_check_t2_n0);
}

void CAwana_grandprix_scoringDlg::OnCheckT2N1() {
	radioCheckButtons(m_check_t2_n1);
}

void CAwana_grandprix_scoringDlg::OnCheckT2N2() {
	radioCheckButtons(m_check_t2_n2);
}

void CAwana_grandprix_scoringDlg::OnCheckT2N3() {
	radioCheckButtons(m_check_t2_n3);
}

void CAwana_grandprix_scoringDlg::OnCheckR1N0() {
	radioCheckButtons(m_check_r1_n0);
}

void CAwana_grandprix_scoringDlg::OnCheckR1N1() {
	radioCheckButtons(m_check_r1_n1);
}

void CAwana_grandprix_scoringDlg::OnCheckR1N2() {
	radioCheckButtons(m_check_r1_n2);
}

void CAwana_grandprix_scoringDlg::OnCheckR1N3() {
	radioCheckButtons(m_check_r1_n3);
}

void CAwana_grandprix_scoringDlg::OnCheckR2N0() {
	radioCheckButtons(m_check_r2_n0);
}

void CAwana_grandprix_scoringDlg::OnCheckR2N1() {
	radioCheckButtons(m_check_r2_n1);
}

void CAwana_grandprix_scoringDlg::OnCheckR2N2() {
	radioCheckButtons(m_check_r2_n2);
}

void CAwana_grandprix_scoringDlg::OnCheckR2N3() {
	radioCheckButtons(m_check_r2_n3);
}

void CAwana_grandprix_scoringDlg::setExceptButton(CButton &pTargetButton) {
  if (!mExceptButton) {
    return;
  }

  // if we have an except button set, then set it with the contents of the
  // target button

  // - get text from target button
  char theText[1024];
  pTargetButton.GetWindowText(theText, 1024);
  
  int theNumber;
  if (strcmp(theText, "--") == 0) {
    theNumber = -1;
  } else {
    theNumber = atoi(theText);
  }

  // - determine what the except button is
  int theSection = -1;
  int theTrack = -1;
  int theLane = -1;

  if        (mExceptButton == &m_check_t1_n0) {
    theSection = 0;
    theTrack = 0;
    theLane = 0;
  } else if (mExceptButton == &m_check_t1_n1) {
    theSection = 0;
    theTrack = 0;
    theLane = 1;
  } else if (mExceptButton == &m_check_t1_n2) {
    theSection = 0;
    theTrack = 0;
    theLane = 2;
  } else if (mExceptButton == &m_check_t1_n3) {
    theSection = 0;
    theTrack = 0;
    theLane = 3;
  } else if (mExceptButton == &m_check_t2_n0) {
    theSection = 0;
    theTrack = 1;
    theLane = 0;
  } else if (mExceptButton == &m_check_t2_n1) {
    theSection = 0;
    theTrack = 1;
    theLane = 1;
  } else if (mExceptButton == &m_check_t2_n2) {
    theSection = 0;
    theTrack = 1;
    theLane = 2;
  } else if (mExceptButton == &m_check_t2_n3) {
    theSection = 0;
    theTrack = 1;
    theLane = 3;
  } else if (mExceptButton == &m_check_r1_n0) {
    theSection = 1;
    theTrack = 0;
    theLane = 0;
  } else if (mExceptButton == &m_check_r1_n1) {
    theSection = 1;
    theTrack = 0;
    theLane = 1;
  } else if (mExceptButton == &m_check_r1_n2) {
    theSection = 1;
    theTrack = 0;
    theLane = 2;
  } else if (mExceptButton == &m_check_r1_n3) {
    theSection = 1;
    theTrack = 0;
    theLane = 3;
  } else if (mExceptButton == &m_check_r2_n0) {
    theSection = 1;
    theTrack = 1;
    theLane = 0;
  } else if (mExceptButton == &m_check_r2_n1) {
    theSection = 1;
    theTrack = 1;
    theLane = 1;
  } else if (mExceptButton == &m_check_r2_n2) {
    theSection = 1;
    theTrack = 1;
    theLane = 2;
  } else if (mExceptButton == &m_check_r2_n3) {
    theSection = 1;
    theTrack = 1;
    theLane = 3;
  }

  // - uncheck all check buttons
  clearAllCheckButtons();

  // - set in model
  if (theSection == 0) {
    mModel.trackUnselect(theTrack, theLane);
    mModel.trackSelect(theTrack, theLane, theNumber);
  } else if (theSection == 1) {
    int theSavedPlace = mModel.raceGetResult(theTrack, theLane);
    mModel.raceUnsetNumber(theTrack, theLane);
    mModel.raceSetNumber(theTrack, theLane, theNumber);
    mModel.raceSetResult(theTrack, theLane, theSavedPlace);

    // compact results if necessary
    if (theNumber == -1) {
      mModel.raceCompactResults(theTrack);
    }
  }

  // - refresh
  refreshFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonPool00() {
  setExceptButton(m_button_pool_0_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool10() {
  setExceptButton(m_button_pool_1_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool20() {
  setExceptButton(m_button_pool_2_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool30() {
  setExceptButton(m_button_pool_3_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool40() {
  setExceptButton(m_button_pool_4_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool50() {
  setExceptButton(m_button_pool_5_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool60() {
  setExceptButton(m_button_pool_6_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool70() {
  setExceptButton(m_button_pool_7_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool80() {
  setExceptButton(m_button_pool_8_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool90() {
  setExceptButton(m_button_pool_9_0);
}

void CAwana_grandprix_scoringDlg::OnButtonPool01() {
  setExceptButton(m_button_pool_0_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool11() {
  setExceptButton(m_button_pool_1_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool21() {
  setExceptButton(m_button_pool_2_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool31() {
  setExceptButton(m_button_pool_3_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool41() {
  setExceptButton(m_button_pool_4_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool51() {
  setExceptButton(m_button_pool_5_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool61() {
  setExceptButton(m_button_pool_6_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool71() {
  setExceptButton(m_button_pool_7_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool81() {
  setExceptButton(m_button_pool_8_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool91() {
  setExceptButton(m_button_pool_9_1);
}

void CAwana_grandprix_scoringDlg::OnButtonPool02() {
  setExceptButton(m_button_pool_0_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool12() {
  setExceptButton(m_button_pool_1_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool22() {
  setExceptButton(m_button_pool_2_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool32() {
  setExceptButton(m_button_pool_3_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool42() {
  setExceptButton(m_button_pool_4_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool52() {
  setExceptButton(m_button_pool_5_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool62() {
  setExceptButton(m_button_pool_6_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool72() {
  setExceptButton(m_button_pool_7_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool82() {
  setExceptButton(m_button_pool_8_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPool92() {
  setExceptButton(m_button_pool_9_2);
}

void CAwana_grandprix_scoringDlg::OnButtonPoolNullvalue() {
  setExceptButton(m_button_pool_nullvalue);
}

void CAwana_grandprix_scoringDlg::OnButtonNewround() {
	mModel.setAllInPoolRaceable();
  refreshFromModel();
}

void CAwana_grandprix_scoringDlg::OnButtonEliminate() {
	CDialogEliminate theDialog;
  int theRetVal = theDialog.DoModal();

  if (theRetVal == IDOK) {
    // if the dialog is ok'ed, then eliminate according to the dialog values
    int theQuantity = atoi(theDialog.m_quantity);
    int theScore = atoi(theDialog.m_score);

    mModel.eliminate(theQuantity, theScore);
    
    // autosave a second time as a checkpoint
    mModel.autosave();
    refreshFromModel();
  }
}

void CAwana_grandprix_scoringDlg::OnButtonEdit() {
  CDialogEditPool theDialog;
  theDialog.mModel = &mModel;

  theDialog.DoModal();

  refreshFromModel();
}
