// awana_grandprix_scoringDlg.h : header file
//

#if !defined(AFX_AWANA_GRANDPRIX_SCORINGDLG_H__D9ABB797_0EBA_4143_9E91_78DDFD1C5D84__INCLUDED_)
#define AFX_AWANA_GRANDPRIX_SCORINGDLG_H__D9ABB797_0EBA_4143_9E91_78DDFD1C5D84__INCLUDED_

#include "Model.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CAwana_grandprix_scoringDlg dialog

#ifdef _MSC_VER
  // microsoft vc++ specific
  #pragma warning(disable:4786)
#endif

#include <list>

using namespace std;


class CAwana_grandprix_scoringDlg : public CDialog
{
// Construction
public:
	int mScoreFirstLineToDisplay;
	void setExceptButton(CButton &pTargetButton);
	CButton* mExceptButton;
	void radioCheckButtons(CButton &pExceptButton);
	void clearAllCheckButtons();
	int mPoolFirstLineToDisplay;
	CModel mModel;
	void refreshFromModel();
	void refreshScoresFromModel();
	void refreshPoolFromModel();
	void initPoolButtonPointers();
	void invalidateScoresButtons();
	CAwana_grandprix_scoringDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAwana_grandprix_scoringDlg)
	enum { IDD = IDD_AWANA_GRANDPRIX_SCORING_DIALOG };
	CButton	m_button_pool_nullvalue;
	CButton	m_button_pool_9_2;
	CButton	m_button_pool_9_1;
	CButton	m_button_pool_9_0;
	CButton	m_button_pool_8_2;
	CButton	m_button_pool_8_1;
	CButton	m_button_pool_8_0;
	CButton	m_button_pool_7_2;
	CButton	m_button_pool_7_1;
	CButton	m_button_pool_7_0;
	CButton	m_button_pool_6_2;
	CButton	m_button_pool_6_1;
	CButton	m_button_pool_6_0;
	CButton	m_button_pool_5_2;
	CButton	m_button_pool_5_1;
	CButton	m_button_pool_5_0;
	CButton	m_button_pool_4_2;
	CButton	m_button_pool_4_1;
	CButton	m_button_pool_4_0;
	CButton	m_button_pool_3_2;
	CButton	m_button_pool_3_1;
	CButton	m_button_pool_3_0;
	CButton	m_button_pool_2_2;
	CButton	m_button_pool_2_1;
	CButton	m_button_pool_2_0;
	CButton	m_button_pool_1_2;
	CButton	m_button_pool_1_1;
	CButton	m_button_pool_1_0;
	CButton	m_button_pool_0_2;
	CButton	m_button_pool_0_1;
	CButton	m_button_pool_0_0;
	CButton	m_button_edit_scrolldown;
	CButton	m_button_edit_scrollup;
	CButton	m_button_edit;
	CButton	m_button_redo;
	CButton	m_button_undo;
	CButton	m_button_eliminate;
	CButton	m_button_newround;
	CEdit	m_edit_scores;
	CButton	m_button_scores_scrolldown;
	CButton	m_button_scores_scrollup;
	CButton	m_check_scores_autoscroll;
	CButton	m_button_r2_record;
	CButton	m_button_r2_p3;
	CButton	m_button_r2_p2;
	CButton	m_button_r2_p1;
	CButton	m_button_r2_p0;
	CButton	m_check_r2_n3;
	CButton	m_check_r2_n2;
	CButton	m_check_r2_n1;
	CButton	m_check_r2_n0;
	CButton	m_button_t2_race;
	CButton	m_check_t2_l3;
	CButton	m_check_t2_l2;
	CButton	m_check_t2_l1;
	CButton	m_check_t2_l0;
	CButton	m_check_t2_n3;
	CButton	m_check_t2_n2;
	CButton	m_check_t2_n1;
	CButton	m_check_t2_n0;
	CButton	m_button_t2_reselect;
	CButton	m_button_r1_record;
	CButton	m_button_r1_p3;
	CButton	m_button_r1_p2;
	CButton	m_button_r1_p1;
	CButton	m_button_r1_p0;
	CButton	m_check_r1_n3;
	CButton	m_check_r1_n2;
	CButton	m_check_r1_n1;
	CButton	m_check_r1_n0;
	CButton	m_button_t1_race;
	CButton	m_check_t1_l3;
	CButton	m_check_t1_l2;
	CButton	m_check_t1_l1;
	CButton	m_check_t1_l0;
	CButton	m_check_t1_n3;
	CButton	m_check_t1_n2;
	CButton	m_check_t1_n1;
	CButton	m_check_t1_n0;
	CButton	m_button_t1_reselect;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAwana_grandprix_scoringDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAwana_grandprix_scoringDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonEditScrollup();
	afx_msg void OnButtonEditScrolldown();
	afx_msg void OnCheckScoresAutoscroll();
	afx_msg void OnButtonScoresScrollup();
	afx_msg void OnButtonScoresScrolldown();
	afx_msg void OnButtonT1Reselect();
	afx_msg void OnButtonT2Reselect();
	afx_msg void OnButtonT1Race();
	afx_msg void OnButtonT2Race();
	afx_msg void OnButtonR1Record();
	afx_msg void OnButtonR2Record();
	afx_msg void OnButtonR1P0();
	afx_msg void OnButtonR1P1();
	afx_msg void OnButtonR1P2();
	afx_msg void OnButtonR1P3();
	afx_msg void OnButtonR2P0();
	afx_msg void OnButtonR2P1();
	afx_msg void OnButtonR2P2();
	afx_msg void OnButtonR2P3();
	afx_msg void OnButtonUndo();
	afx_msg void OnButtonRedo();
	afx_msg void OnCheckT1N0();
	afx_msg void OnCheckT1N1();
	afx_msg void OnCheckT1N2();
	afx_msg void OnCheckT1N3();
	afx_msg void OnCheckT2N0();
	afx_msg void OnCheckT2N1();
	afx_msg void OnCheckT2N2();
	afx_msg void OnCheckT2N3();
	afx_msg void OnCheckR1N0();
	afx_msg void OnCheckR1N1();
	afx_msg void OnCheckR1N2();
	afx_msg void OnCheckR1N3();
	afx_msg void OnCheckR2N0();
	afx_msg void OnCheckR2N1();
	afx_msg void OnCheckR2N2();
	afx_msg void OnCheckR2N3();
	afx_msg void OnButtonPool00();
	afx_msg void OnButtonPool10();
	afx_msg void OnButtonPool20();
	afx_msg void OnButtonPool30();
	afx_msg void OnButtonPool40();
	afx_msg void OnButtonPool50();
	afx_msg void OnButtonPool60();
	afx_msg void OnButtonPool70();
	afx_msg void OnButtonPool80();
	afx_msg void OnButtonPool90();
	afx_msg void OnButtonPool01();
	afx_msg void OnButtonPool11();
	afx_msg void OnButtonPool21();
	afx_msg void OnButtonPool31();
	afx_msg void OnButtonPool41();
	afx_msg void OnButtonPool51();
	afx_msg void OnButtonPool61();
	afx_msg void OnButtonPool71();
	afx_msg void OnButtonPool81();
	afx_msg void OnButtonPool91();
	afx_msg void OnButtonPool02();
	afx_msg void OnButtonPool12();
	afx_msg void OnButtonPool22();
	afx_msg void OnButtonPool32();
	afx_msg void OnButtonPool42();
	afx_msg void OnButtonPool52();
	afx_msg void OnButtonPool62();
	afx_msg void OnButtonPool72();
	afx_msg void OnButtonPool82();
	afx_msg void OnButtonPool92();
	afx_msg void OnButtonPoolNullvalue();
	afx_msg void OnButtonNewround();
	afx_msg void OnButtonEliminate();
	afx_msg void OnButtonEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
  // temporary pool structure
  typedef list<int> tIntLIST;

  // used internally by timer...
  bool mOkToInvalidateScoresButtons;

  // pool button pointers
  CButton* mPoolButtons[10][3];
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AWANA_GRANDPRIX_SCORINGDLG_H__D9ABB797_0EBA_4143_9E91_78DDFD1C5D84__INCLUDED_)
